<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'updateEvent' => '\\StructType\\UpdateEvent',
            'businessEvent' => '\\StructType\\BusinessEvent',
            'annotation' => '\\StructType\\Annotation',
            'wsValuedEntry' => '\\StructType\\WsValuedEntry',
            'wsEntry' => '\\StructType\\WsEntry',
            'extendedAttachment' => '\\StructType\\ExtendedAttachment',
            'attachment' => '\\StructType\\Attachment',
            'completionData' => '\\StructType\\CompletionData',
            'reportElement' => '\\StructType\\ReportElement',
            'reportField' => '\\StructType\\ReportField',
            'tableSection' => '\\StructType\\TableSection',
            'rowSection' => '\\StructType\\RowSection',
            'extendedReportElement' => '\\StructType\\ExtendedReportElement',
            'extendedReportField' => '\\StructType\\ExtendedReportField',
            'extendedReportSection' => '\\StructType\\ExtendedReportSection',
            'extendedReportFieldDropDownMenu' => '\\StructType\\ExtendedReportFieldDropDownMenu',
            'extendedReportFieldPhoto' => '\\StructType\\ExtendedReportFieldPhoto',
            'extendedReportFieldRLDropDownMenu' => '\\StructType\\ExtendedReportFieldRLDropDownMenu',
            'extendedReportFieldText' => '\\StructType\\ExtendedReportFieldText',
            'extendedReportFieldUrl' => '\\StructType\\ExtendedReportFieldUrl',
            'lifecycleTransitionDate' => '\\StructType\\LifecycleTransitionDate',
            'usedItem' => '\\StructType\\UsedItem',
            'coreData' => '\\StructType\\CoreData',
            'contact' => '\\StructType\\Contact',
            'referentialData' => '\\StructType\\ReferentialData',
            'serviceOrder' => '\\StructType\\ServiceOrder',
            'serviceOrderPosition' => '\\StructType\\ServiceOrderPosition',
            'serviceOrderInsertion' => '\\StructType\\ServiceOrderInsertion',
            'externalReferentialData' => '\\StructType\\ExternalReferentialData',
            'location' => '\\StructType\\Location',
            'geolocation' => '\\StructType\\Geolocation',
            'praxedoReferentialData' => '\\StructType\\PraxedoReferentialData',
            'tripReferentialData' => '\\StructType\\TripReferentialData',
            'qualificationData' => '\\StructType\\QualificationData',
            'extendedItem' => '\\StructType\\ExtendedItem',
            'businessEventType' => '\\StructType\\BusinessEventType',
            'skill' => '\\StructType\\Skill',
            'schedulingData' => '\\StructType\\SchedulingData',
            'entityId' => '\\StructType\\EntityId',
            'praxedoEntityId' => '\\StructType\\PraxedoEntityId',
            'externalEntityId' => '\\StructType\\ExternalEntityId',
            'updateEventResponse' => '\\StructType\\UpdateEventResponse',
            'operationResult' => '\\StructType\\OperationResult',
            'simpleOperationResult' => '\\StructType\\SimpleOperationResult',
            'cancelEvent' => '\\StructType\\CancelEvent',
            'cancellationRequest' => '\\StructType\\CancellationRequest',
            'cancelEventResponse' => '\\StructType\\CancelEventResponse',
            'searchEvents' => '\\StructType\\SearchEvents',
            'businessEventsRequest' => '\\StructType\\BusinessEventsRequest',
            'dateConstraint' => '\\StructType\\DateConstraint',
            'serviceOrderConstraint' => '\\StructType\\ServiceOrderConstraint',
            'searchEventsResponse' => '\\StructType\\SearchEventsResponse',
            'businessEventsRequestResult' => '\\StructType\\BusinessEventsRequestResult',
            'entitiesRequestResult' => '\\StructType\\EntitiesRequestResult',
            'deleteEvents' => '\\StructType\\DeleteEvents',
            'deleteEventsResponse' => '\\StructType\\DeleteEventsResponse',
            'entitiesOperationResult' => '\\StructType\\EntitiesOperationResult',
            'entityOperationResult' => '\\StructType\\EntityOperationResult',
            'getEvents' => '\\StructType\\GetEvents',
            'getEventsResponse' => '\\StructType\\GetEventsResponse',
            'unscheduleEvent' => '\\StructType\\UnscheduleEvent',
            'unscheduleEventResponse' => '\\StructType\\UnscheduleEventResponse',
            'scheduleEvent' => '\\StructType\\ScheduleEvent',
            'scheduleEventResponse' => '\\StructType\\ScheduleEventResponse',
            'invalidateEvent' => '\\StructType\\InvalidateEvent',
            'invalidateEventResponse' => '\\StructType\\InvalidateEventResponse',
            'createEvents' => '\\StructType\\CreateEvents',
            'createEventsResponse' => '\\StructType\\CreateEventsResponse',
            'addAnnotation' => '\\StructType\\AddAnnotation',
            'addAnnotationResponse' => '\\StructType\\AddAnnotationResponse',
        );
    }
}
