<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for cancellationRequest StructType
 * @subpackage Structs
 */
class CancellationRequest extends AbstractStructBase
{
    /**
     * The message
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $message;
    /**
     * The reasonCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $reasonCode;
    /**
     * Constructor method for cancellationRequest
     * @uses CancellationRequest::setMessage()
     * @uses CancellationRequest::setReasonCode()
     * @param string $message
     * @param string $reasonCode
     */
    public function __construct($message = null, $reasonCode = null)
    {
        $this
            ->setMessage($message)
            ->setReasonCode($reasonCode);
    }
    /**
     * Get message value
     * @return string|null
     */
    public function getMessage()
    {
        return $this->message;
    }
    /**
     * Set message value
     * @param string $message
     * @return \StructType\CancellationRequest
     */
    public function setMessage($message = null)
    {
        // validation for constraint: string
        if (!is_null($message) && !is_string($message)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($message, true), gettype($message)), __LINE__);
        }
        $this->message = $message;
        return $this;
    }
    /**
     * Get reasonCode value
     * @return string|null
     */
    public function getReasonCode()
    {
        return $this->reasonCode;
    }
    /**
     * Set reasonCode value
     * @param string $reasonCode
     * @return \StructType\CancellationRequest
     */
    public function setReasonCode($reasonCode = null)
    {
        // validation for constraint: string
        if (!is_null($reasonCode) && !is_string($reasonCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($reasonCode, true), gettype($reasonCode)), __LINE__);
        }
        $this->reasonCode = $reasonCode;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CancellationRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
