<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for extendedReportFieldText StructType
 * @subpackage Structs
 */
class ExtendedReportFieldText extends ExtendedReportField
{
    /**
     * The comment
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $comment;
    /**
     * The example
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $example;
    /**
     * The regexp
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $regexp;
    /**
     * Constructor method for extendedReportFieldText
     * @uses ExtendedReportFieldText::setComment()
     * @uses ExtendedReportFieldText::setExample()
     * @uses ExtendedReportFieldText::setRegexp()
     * @param string $comment
     * @param string $example
     * @param string $regexp
     */
    public function __construct($comment = null, $example = null, $regexp = null)
    {
        $this
            ->setComment($comment)
            ->setExample($example)
            ->setRegexp($regexp);
    }
    /**
     * Get comment value
     * @return string|null
     */
    public function getComment()
    {
        return $this->comment;
    }
    /**
     * Set comment value
     * @param string $comment
     * @return \StructType\ExtendedReportFieldText
     */
    public function setComment($comment = null)
    {
        // validation for constraint: string
        if (!is_null($comment) && !is_string($comment)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($comment, true), gettype($comment)), __LINE__);
        }
        $this->comment = $comment;
        return $this;
    }
    /**
     * Get example value
     * @return string|null
     */
    public function getExample()
    {
        return $this->example;
    }
    /**
     * Set example value
     * @param string $example
     * @return \StructType\ExtendedReportFieldText
     */
    public function setExample($example = null)
    {
        // validation for constraint: string
        if (!is_null($example) && !is_string($example)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($example, true), gettype($example)), __LINE__);
        }
        $this->example = $example;
        return $this;
    }
    /**
     * Get regexp value
     * @return string|null
     */
    public function getRegexp()
    {
        return $this->regexp;
    }
    /**
     * Set regexp value
     * @param string $regexp
     * @return \StructType\ExtendedReportFieldText
     */
    public function setRegexp($regexp = null)
    {
        // validation for constraint: string
        if (!is_null($regexp) && !is_string($regexp)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($regexp, true), gettype($regexp)), __LINE__);
        }
        $this->regexp = $regexp;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ExtendedReportFieldText
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
