<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for tripReferentialData StructType
 * @subpackage Structs
 */
class TripReferentialData extends ReferentialData
{
    /**
     * The end
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ReferentialData
     */
    public $end;
    /**
     * The extensions
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\WsValuedEntry[]
     */
    public $extensions;
    /**
     * The start
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ReferentialData
     */
    public $start;
    /**
     * Constructor method for tripReferentialData
     * @uses TripReferentialData::setEnd()
     * @uses TripReferentialData::setExtensions()
     * @uses TripReferentialData::setStart()
     * @param \StructType\ReferentialData $end
     * @param \StructType\WsValuedEntry[] $extensions
     * @param \StructType\ReferentialData $start
     */
    public function __construct(\StructType\ReferentialData $end = null, array $extensions = array(), \StructType\ReferentialData $start = null)
    {
        $this
            ->setEnd($end)
            ->setExtensions($extensions)
            ->setStart($start);
    }
    /**
     * Get end value
     * @return \StructType\ReferentialData|null
     */
    public function getEnd()
    {
        return $this->end;
    }
    /**
     * Set end value
     * @param \StructType\ReferentialData $end
     * @return \StructType\TripReferentialData
     */
    public function setEnd(\StructType\ReferentialData $end = null)
    {
        $this->end = $end;
        return $this;
    }
    /**
     * Get extensions value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\WsValuedEntry[]|null
     */
    public function getExtensions()
    {
        return isset($this->extensions) ? $this->extensions : null;
    }
    /**
     * This method is responsible for validating the values passed to the setExtensions method
     * This method is willingly generated in order to preserve the one-line inline validation within the setExtensions method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateExtensionsForArrayConstraintsFromSetExtensions(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $tripReferentialDataExtensionsItem) {
            // validation for constraint: itemType
            if (!$tripReferentialDataExtensionsItem instanceof \StructType\WsValuedEntry) {
                $invalidValues[] = is_object($tripReferentialDataExtensionsItem) ? get_class($tripReferentialDataExtensionsItem) : sprintf('%s(%s)', gettype($tripReferentialDataExtensionsItem), var_export($tripReferentialDataExtensionsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The extensions property can only contain items of type \StructType\WsValuedEntry, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set extensions value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\WsValuedEntry[] $extensions
     * @return \StructType\TripReferentialData
     */
    public function setExtensions(array $extensions = array())
    {
        // validation for constraint: array
        if ('' !== ($extensionsArrayErrorMessage = self::validateExtensionsForArrayConstraintsFromSetExtensions($extensions))) {
            throw new \InvalidArgumentException($extensionsArrayErrorMessage, __LINE__);
        }
        if (is_null($extensions) || (is_array($extensions) && empty($extensions))) {
            unset($this->extensions);
        } else {
            $this->extensions = $extensions;
        }
        return $this;
    }
    /**
     * Add item to extensions value
     * @throws \InvalidArgumentException
     * @param \StructType\WsValuedEntry $item
     * @return \StructType\TripReferentialData
     */
    public function addToExtensions(\StructType\WsValuedEntry $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\WsValuedEntry) {
            throw new \InvalidArgumentException(sprintf('The extensions property can only contain items of type \StructType\WsValuedEntry, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->extensions[] = $item;
        return $this;
    }
    /**
     * Get start value
     * @return \StructType\ReferentialData|null
     */
    public function getStart()
    {
        return $this->start;
    }
    /**
     * Set start value
     * @param \StructType\ReferentialData $start
     * @return \StructType\TripReferentialData
     */
    public function setStart(\StructType\ReferentialData $start = null)
    {
        $this->start = $start;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\TripReferentialData
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
